VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Shell"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessID As Long) As Long
Private Declare Function CreatePipe Lib "kernel32" (phReadPipe As Long, phWritePipe As Long, lpPipeAttributes As Any, ByVal nSize As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As String, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, lpProcessAttributes As Any, lpThreadAttributes As Any, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As Any, lpProcessInformation As Any) As Long
Private Declare Function CreateProcessWithLogonW Lib "Advapi32" (ByVal lpUserName As Long, ByVal lpDomain As Long, ByVal lpPassword As Long, ByVal dwLogonFlags As Long, ByVal lpApplicationName As Long, ByVal lpCommandLine As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As STARTUPINFO, lpProcessInfo As PROCESS_INFORMATION) As Long

Private Type SECURITY_ATTRIBUTES
    nLength              As Long
    lpSecurityDescriptor As Long
    bInheritHandle       As Long
End Type

Private Type STARTUPINFO
    cb              As Long
    lpReserved      As Long
    lpDesktop       As Long
    lpTitle         As Long
    dwX             As Long
    dwY             As Long
    dwXSize         As Long
    dwYSize         As Long
    dwXCountChars   As Long
    dwYCountChars   As Long
    dwFillAttribute As Long
    dwFlags         As Long
    wShowWindow     As Integer
    cbReserved2     As Integer
    lpReserved2     As Long
    hStdInput       As Long
    hStdOutput      As Long
    hStdError       As Long
End Type


Private Const STILL_ACTIVE = &H103&
Public Function Execute(Path As String, Optional Param As String = "", Optional WinStyle As VbAppWinStyle = vbNormalFocus) As Boolean
    Dim Result As Long
    
    Result = ShellExecute(0, "Open", Path, Param, "", WinStyle)

    If Result > 32 Then Execute = True

End Function
Public Function ExecuteAndWait(ByVal AppPath As String, _
                               Optional ByVal WindowStyle As VbAppWinStyle = vbNormalFocus) _
                                        As Long
    Dim PROCID As Long, ProcHnd As Long, Active As Long

    On Local Error GoTo Quit

    PROCID = SHELL(AppPath, WindowStyle)
    ProcHnd = OpenProcess(PROCESS_QUERY_INFORMATION, True, PROCID)

    Do
        DoEvents
        Call GetExitCodeProcess(ProcHnd, Active)
    Loop While Active = STILL_ACTIVE

    Call CloseHandle(ProcHnd)
    
    DoEvents
    
    Exit Function
    
Quit:
    ExecuteAndWait = Err.Number
    
    Call ERROR(SHELL_, "ExecuteAndWait", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function WaitForTask(Optional Path As String, _
                            Optional WindowCaption As String, _
                            Optional ErrorNumber As Long) As Boolean
    Dim PROCID As Long, ProcHnd As Long, hwnd As Long, Index As Long, Work As Long
    Dim PI() As PROCESSINFO
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Path <> "" Then
        PI = DLL.SYSTEM.Get_ProcessList(True)
    
        Index = ProcessFind(PI, Path)
        PROCID = PI(Index).PROCESSID
    Else
        hwnd = DLL.WINDOW.FindWindow("", WindowCaption)
        PROCID = DLL.WINDOW.Get_TaskID(hwnd)
    End If
    
    ProcHnd = OpenProcess(PROCESS_QUERY_INFORMATION, True, PROCID)
        
    Do
        DoEvents
        
        Call GetExitCodeProcess(ProcHnd, Work)
    Loop While Work = STILL_ACTIVE
        
    WaitForTask = True
    
Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        
        Call ERROR(SHELL_, "WaitForTask", Err.Number, Err.Description)
    End If
    
    Call CloseHandle(ProcHnd)

    Err.Clear
    
End Function
Public Function DOS_Execute(ByVal Command As String, Optional Param As String = "") As String
    Dim Proc As PROCESS_INFORMATION
    Dim Result As Long, bSuccess As Long, hReadPipe As Long
    Dim hWritePipe As Long, L As Long
    Dim Start As STARTUPINFO
    Dim Sa As SECURITY_ATTRIBUTES
    Dim Buffer As String
     
    Const STARTF_USESTDHANDLES = &H100&
    Const NORMAL_PRIORITY_CLASS = &H20&

    If Param <> "" Then Command = Command & " " & Param

    Sa.nLength = Len(Sa)
    Sa.bInheritHandle = 1&
    Sa.lpSecurityDescriptor = 0&
    
    Result = CreatePipe(hReadPipe, hWritePipe, Sa, 0)
    If Result = 0 Then GoTo Quit
    
    Start.cb = Len(Start)
    Start.dwFlags = STARTF_USESTDHANDLES
    Start.hStdOutput = hWritePipe
    
    Result = CreateProcessA(0&, Command, Sa, Sa, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, Start, Proc)
    If Result <> 1 Then GoTo Quit
    
    Buffer = STRING(2000, Chr$(0))
    bSuccess = ReadFile(hReadPipe, Buffer, Len(Buffer), L, 0&)
      
    If bSuccess = 1 Then
        DOS_Execute = Trim(Left$(Buffer, L))
        DOS_Execute = Replace(DOS_Execute, Chr$(0), "")
    End If
    
Quit:
    Call CloseHandle(Proc.hProcess)
    Call CloseHandle(Proc.hThread)
    Call CloseHandle(hReadPipe)
    Call CloseHandle(hWritePipe)

End Function
Public Function RunAsUser(ByVal UserName As String, ByVal Password As String, _
                          ByVal Domain As String, ByVal AppPath As String) As Boolean
    Dim Result As Long
    Dim StartInfo As STARTUPINFO
    Dim PROCESSINFO As PROCESS_INFORMATION
    
    Const LOGON_WITH_PROFILE = &H1&
    Const CREATE_DEFAULT_ERROR_MODE = &H4000000
    Const CREATE_NEW_CONSOLE = &H10&
    Const CREATE_NEW_PROCESS_GROUP = &H200&

    StartInfo.cb = LenB(StartInfo)
    StartInfo.dwFlags = 0&
    
    Result = CreateProcessWithLogonW(strptr(UserName), strptr(Domain), _
                                     strptr(Password), LOGON_WITH_PROFILE, strptr(AppPath), _
                                     strptr(vbNullString), CREATE_DEFAULT_ERROR_MODE Or CREATE_NEW_CONSOLE Or CREATE_NEW_PROCESS_GROUP, _
                                     ByVal 0&, strptr(vbNullString), StartInfo, PROCESSINFO)
                                     
    RunAsUser = (Result <> 0)
    
    Call CloseHandle(PROCESSINFO.hThread)
    Call CloseHandle(PROCESSINFO.hProcess)
    
End Function
