VERSION 5.00
Begin VB.Form frmTMP 
   BorderStyle     =   0  'Kein
   ClientHeight    =   840
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   8055
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   840
   ScaleWidth      =   8055
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame frameDir 
      Height          =   735
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Visible         =   0   'False
      Width           =   7815
      Begin VB.Label lblDir 
         Alignment       =   2  'Zentriert
         BackStyle       =   0  'Transparent
         BorderStyle     =   1  'Fest Einfach
         Caption         =   "%Dir%"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   7575
      End
   End
   Begin VB.PictureBox picTMP 
      Height          =   1215
      Left            =   120
      ScaleHeight     =   1155
      ScaleWidth      =   1755
      TabIndex        =   1
      Top             =   720
      Visible         =   0   'False
      Width           =   1815
   End
   Begin VB.Label LabelTMP 
      BackColor       =   &H00FF0000&
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   2295
   End
End
Attribute VB_Name = "frmTMP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hDC As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Private Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
Private Declare Function SelectPalette Lib "gdi32" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function RealizePalette Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, ByVal fPictureOwnsHandle As Long, ipic As IPicture) As Long

Private Type GUID
    Data1    As Long
    Data2    As Integer
    Data3    As Integer
    Data4(7) As Byte
End Type

Private Type PicBmp
    Size     As Long
    Type     As Long
    hBmp     As Long
    hPal     As Long
    Reserved As Long
End Type

Private Type PALETTEENTRY
    peRed   As Byte
    peGreen As Byte
    peBlue  As Byte
    peFlags As Byte
End Type

Private Type LOGPALETTE
    palVersion       As Integer
    palNumEntries    As Integer
    palPalEntry(255) As PALETTEENTRY
End Type

Private Const RASTERCAPS  As Long = 38
Private Const RC_PALETTE  As Long = &H100
Private Const SIZEPALETTE As Long = 104

Public DesktopText As String

Private Sub Form_Load()
    Me.Visible = False
End Sub
Public Function GetWindowHwnd(ByVal hwnd As Long) As StdPicture
    Dim R As RECT
    
    With PicTMP
        .Top = 0
        .Left = 0
        
        .AutoRedraw = True
        Set .Picture = CaptureActiveWindow(hwnd)
    
        Call GetWindowRect(hwnd, R)
    
        .Width = (R.Right - R.Left) * 15
        .Height = (R.Bottom - R.Top) * 15

        Me.Width = .Width
        Me.Height = .Height
    
        Set GetWindowHwnd = .Picture
    End With
    
End Function
Private Function CaptureActiveWindow(ByVal hwnd As Long) As Picture
    Dim hWndActive As Long
    Dim R As Long
    Dim RectActive As RECT

    hWndActive = hwnd

    R = GetWindowRect(hWndActive, RectActive)

    Set CaptureActiveWindow = CaptureWindow(hWndActive, 0, 0, _
                                            RectActive.Right - RectActive.Left, _
                                            RectActive.Bottom - RectActive.Top)
                            
End Function
Private Function CaptureWindow(ByVal hWndSrc As Long, _
                               ByVal LeftSrc As Long, _
                               ByVal TopSrc As Long, _
                               ByVal WidthSrc As Long, _
                               ByVal HeightSrc As Long) As Picture
    Dim hDCMemory As Long, hBmp As Long, hBmpPrev As Long
    Dim R As Long, hDCSrc As Long, hPal As Long, hPalPrev As Long
    Dim RasterCapsScrn As Long, HasPaletteScrn As Long
    Dim PaletteSizeScrn As Long

    Dim LogPal As LOGPALETTE

    hDCSrc = GetWindowDC(hWndSrc)
    
    hDCMemory = CreateCompatibleDC(hDCSrc)
    hBmp = CreateCompatibleBitmap(hDCSrc, WidthSrc, HeightSrc)
    hBmpPrev = SelectObject(hDCMemory, hBmp)

    RasterCapsScrn = GetDeviceCaps(hDCSrc, RASTERCAPS)
    HasPaletteScrn = RasterCapsScrn And RC_PALETTE
    PaletteSizeScrn = GetDeviceCaps(hDCSrc, SIZEPALETTE)
    
    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        LogPal.palVersion = &H300
        LogPal.palNumEntries = 256
        R = GetSystemPaletteEntries(hDCSrc, 0, 256, _
                                    LogPal.palPalEntry(0))
        hPal = CreatePalette(LogPal)
        hPalPrev = SelectPalette(hDCMemory, hPal, 0)
        R = RealizePalette(hDCMemory)
    End If

    R = BitBlt(hDCMemory, 0, 0, WidthSrc, HeightSrc, _
               hDCSrc, LeftSrc, TopSrc, vbSrcCopy)

    hBmp = SelectObject(hDCMemory, hBmpPrev)

    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
            hPal = SelectPalette(hDCMemory, hPalPrev, 0)
    End If
    
    R = DeleteDC(hDCMemory)
    R = ReleaseDC(hWndSrc, hDCSrc)

    Set CaptureWindow = CreateBitmapPicture(hBmp, hPal)

End Function
Private Function CreateBitmapPicture(ByVal hBmp As Long, _
                                     ByVal hPal As Long) As Picture
    Dim R As Long
    Dim pic As PicBmp
    Dim ipic As IPicture
    Dim IID_IDispatch As GUID

    With IID_IDispatch
        .Data1 = &H20400
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With

    With pic
        .Size = Len(pic)
        .Type = vbPicTypeBitmap
        .hBmp = hBmp
        .hPal = hPal
    End With

    R = OleCreatePictureIndirect(pic, IID_IDispatch, 1, ipic)

    Set CreateBitmapPicture = ipic
    
End Function
